Package weka.filters.unsupervised.instance

# Class Normalize

java.lang.Object
weka.filters.Filter
weka.filters.unsupervised.instance.Normalize

All Implemented Interfaces:
  `Serializable`, `CapabilitiesHandler`, `OptionHandler`, `RevisionHandler`, `UnsupervisedFilter`

public class Normalize extends Filter implements UnsupervisedFilter, OptionHandler
An instance filter that normalize instances considering only numeric attributes and ignoring class index.

Valid options are:

     -N <num>
      Specify the norm that each instance must have (default 1.0)

     -L <num>
      Specify L-norm to use (default 2.0)

Version:
  $Revision: 5548 $
Author:
  Julien Prados
See Also:
  - Serialized Form

## Constructor Summary

Constructors
Constructor
Description
`Normalize()`

## Method Summary

Modifier and Type
Method
Description
`Capabilities`
`getCapabilities()`
Returns the Capabilities of this filter.
`double`
`getLNorm()`
Get the L Norm used.
`double`
`getNorm()`
Get the instance's Norm.
`String[]`
`getOptions()`
Gets the current settings of the filter.
`String`
`getRevision()`
Returns the revision string.
`String`
`globalInfo()`
Returns a string describing this filter
`boolean`
`input(Instance instance)`
Input an instance for filtering.
`Enumeration`
`listOptions()`
Returns an enumeration describing the available options.
`String`
`LNormTipText()`
Returns the tip text for this property
`static void`
`main(String[] argv)`
Main method for testing this class.
`String`
`normTipText()`
Returns the tip text for this property
`boolean`
`setInputFormat(Instances instanceInfo)`
Sets the format of the input instances.
`void`
`setLNorm(double newLNorm)`
Set the L-norm to used
`void`
`setNorm(double newNorm)`
Set the norm of the instances
`void`
`setOptions(String[] options)`
Parses a given list of options.

### Methods inherited from class weka.filters.Filter

`batchFilterFile, batchFinished, filterFile, getCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, numPendingOutput, output, outputPeek, toString, useFilter, wekaStaticWrapper`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### Normalize

public Normalize()

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this filter

Returns:
  a description of the filter suitable for displaying in the explorer/experimenter gui

### LNormTipText

public String LNormTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### normTipText

public String normTipText()
Returns the tip text for this property

Returns:
  tip text for this property suitable for displaying in the explorer/experimenter gui

### listOptions

public Enumeration listOptions()
Returns an enumeration describing the available options.

Specified by:
  `listOptions` in interface `OptionHandler`
Returns:
  an enumeration of all the available options.

### setOptions

public void setOptions(String[] options) throws Exception
Parses a given list of options.

Valid options are:

     -N <num>
      Specify the norm that each instance must have (default 1.0)

     -L <num>
      Specify L-norm to use (default 2.0)

Specified by:
  `setOptions` in interface `OptionHandler`
Parameters:
  `options` - the list of options as an array of strings
Throws:
  `Exception` - if an option is not supported

### getOptions

public String[] getOptions()
Gets the current settings of the filter.

Specified by:
  `getOptions` in interface `OptionHandler`
Returns:
  an array of strings suitable for passing to setOptions

### getNorm

public double getNorm()
Get the instance's Norm.

Returns:
  the Norm

### setNorm

public void setNorm(double newNorm)
Set the norm of the instances

Parameters:
  `newNorm` - the norm to wich the instances must be set

### getLNorm

public double getLNorm()
Get the L Norm used.

Returns:
  the L-norm used

### setLNorm

public void setLNorm(double newLNorm)
Set the L-norm to used

Parameters:
  `newLNorm` - the L-norm

### getCapabilities

public Capabilities getCapabilities()
Returns the Capabilities of this filter.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `Filter`
Returns:
  the capabilities of this object
See Also:
  - `Capabilities`

### setInputFormat

public boolean setInputFormat(Instances instanceInfo) throws Exception
Sets the format of the input instances.

Overrides:
  `setInputFormat` in class `Filter`
Parameters:
  `instanceInfo` - an Instances object containing the input instance structure (any instances contained in the object are ignored - only the structure is required).
Returns:
  true if the outputFormat may be collected immediately
Throws:
  `Exception` - if format cannot be processed

### input

public boolean input(Instance instance) throws Exception
Input an instance for filtering. Ordinarily the instance is processed and made available for output immediately. Some filters require all instances be read before producing output.

Overrides:
  `input` in class `Filter`
Parameters:
  `instance` - the input instance
Returns:
  true if the filtered instance may now be collected with output().
Throws:
  `IllegalStateException` - if no input format has been defined.
  `Exception` - if the input instance was not of the correct format or if there was a problem with the filtering.

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `Filter`
Returns:
  the revision

### main

public static void main(String[] argv)
Main method for testing this class.

Parameters:
  `argv` - should contain arguments to the filter: use -h for help